function graph = buildGraph(idIm,params,funExtract)
    
    % Set up multiscale superpixel adjacencies
    IdScale = 3:6;
    for i=1:length(IdScale)
        ImSeg(:,:,i) = readSeg(sprintf('preprocess/%s/%s-seg-scale%03d.seg',idIm,idIm,IdScale(i)));
    end
    for i=1:size(ImSeg,3)    
        imSeg = ImSeg(:,:,i);
        adjMat = SuperpixelAdjacencyGraphNcuts(imSeg);
        graph_single(i).imSeg = imSeg;
        graph_single(i).nVert = size(adjMat,1);
        graph_single(i).adjmat = adjMat;
    end
    
    switch params.graph.id
        case 'Binary'
            graph = buildGraphUni(graph_single,funExtract);
        case 'Ternary'
            graph = buildGraphUni(graph_single,funExtract);
        case 'TernaryXscale'
            graph = buildGraphUni(graph_single,funExtract,1);
    end

end
