% This code computes symmetric part detections in an image as described in:
% T. Lee, S. Fidler, S. Dickinson.
% Detecting Curved Symmetric Parts using a Deformable Disc Model.
% IEEE International Conference on Computer Vision, 2013.

% Set paths
restoredefaultpath;
addpath('./display');
addpath('./features');
addpath(genpath('./external'));

% Set parameters
clear global params;
global params;

params.graph.id = 'Ternary';
params.graph.vis = 0;
params.graph.recompute = 0;

params.grouping.id = 'seq';
params.grouping.vis = 0; % set this to make PDF showing overlaid detections
params.grouping.recompute = 0;

params.feature.id = 'DefDisc';
params.feature.minScore = 0.1;

params.feature.string = sprintf('%s', ...
   params.feature.id);
params.graph.string = sprintf('Graph__%s_%s_%s', ...
   params.graph.id, params.feature.string);
params.grouping.string = sprintf('TopParts__%s_%s_%s', ...
   params.graph.id, params.feature.string);


% Set pointers to input images
% - reads images from './data/' (assumes '.jpg' extension)

IdIm={'demo_jet'};
% IdIm={'demo_jet' 'demo_snake'};
% load('IdDataset','IdIm');  % points to images in BSDS-Parts


% Compute superpixels and features for each image
% - saves results to './preprocess/'

preprocess;



% Detect symmetric parts for each image
% - saves results to './detect/'

detect;

