function IpartsOut = targetExamplesPlotParts(iFig, im, graph, parts, minScore, ordinal, Iparts, label)

if ~exist('Iparts','var')
    Iparts=[];
end

if ~exist('label','var')
    label=0;
end

    figure(iFig);
imPlot = im2double(im);

% for z=1:length(graph)
    [imPlot IpartsOut] = targetExamplesPlotParts_sub1(iFig, imPlot, graph, parts, minScore, ordinal, Iparts);    
% end

imagesc(imPlot);
axis equal;

% for z=1:length(graph)
    targetExamplesPlotParts_sub2(iFig, imPlot, graph, parts, minScore, ordinal, Iparts, label);    
% end

end




function [imPlotOut Ithres] = targetExamplesPlotParts_sub1(iFig, imPlot, graph, parts, minScore, ordinal, Iparts)
    
        colours=jet(101);


if exist('Iparts','var') && ~isempty(Iparts)
    Ithres=Iparts;
else

    if isempty(minScore)
        i=min(ordinal,length(parts.scores));
        sorted=sort(parts.scores,'descend');
        if i==length(parts.scores)
            minScore = -inf;
        else
            minScore = mean(sorted(i:i+1));
        end    
    end



    % nRegion = length(parts.scores);
    Ithres = find(parts.scores >= minScore);

    fprintf('--- thres=Inf ---\n');
    for i=1:length(Ithres)
        iRegion = Ithres(i);
        fprintf('part#%02d score=%0.4f\n', iRegion, parts.scores(iRegion));
    end

    fprintf('--- thres=%0.4f ---\n', minScore);
    I = tlInvertIds(Ithres,length(parts.scores));
    [~,a]=sort(parts.scores(I),'descend');
    for i=1:min(3,length(a))
        iRegion = I(a(i));
        fprintf('part#%02d score=%0.4f\n', iRegion, parts.scores(iRegion));
    end

end

colours = lines(length(Ithres));
for i=1:length(Ithres)
    iRegion = Ithres(i);

    mask = logical(parts.imRegions(:,:,iRegion));        
    
    colour = colours(i,:);
%     colour = colours( ceil(parts.scores(iRegion)*(size(colours,1)-1))+1 , :);
    imPlot=tlMaskOnIm(imPlot,mask,colour,.5);
end

imPlotOut=imPlot;

end




function targetExamplesPlotParts_sub2(iFig, im, graph, parts, minScore, ordinal, Iparts, label)
    
        colours=jet(101);

    figure(iFig);
if exist('Iparts','var') && ~isempty(Iparts)
    Ithres=Iparts;
else

    if isempty(minScore)
        i=min(ordinal,length(parts.scores));
        sorted=sort(parts.scores,'descend');
        if i==length(parts.scores)
            minScore = -inf;
        else
            minScore = mean(sorted(i:i+1));
        end    
    end



    % nRegion = length(parts.scores);
    Ithres = find(parts.scores >= minScore);

%     fprintf('--- thres=Inf ---\n');
%     for i=1:length(Ithres)
%         iRegion = Ithres(i);
%         fprintf('part#%02d score=%0.4f segs=%s\n', iRegion, parts.scores(iRegion), mat2str(parts.Isegs{iRegion}));
%     end
% 
%     fprintf('--- thres=%0.4f ---\n', minScore);
%     I = tlInvertIds(Ithres,length(parts.scores));
%     [~,a]=sort(parts.scores(I),'descend');
%     for i=1:min(3,length(a))
%         iRegion = I(a(i));
%         fprintf('part#%02d score=%0.4f segs=%s\n', iRegion, parts.scores(iRegion), mat2str(parts.Isegs{iRegion}));
%     end

end


for i=1:length(Ithres)
    iRegion = Ithres(i);

    for j=1:length(parts.Seq{iRegion})
        Ivert = graph.S(:,parts.Seq{iRegion}(j));
        
        bw1 = graph.iVert2bw(Ivert(1));
        bw2 = graph.iVert2bw(Ivert(2));
        
        [R C] = find(bw1);
        P1 = mean([C R],1);
        [R C] = find(bw2);
        P2 = mean([C R],1);  

        colour='g';
        line([P1(1) P2(1)], [P1(2) P2(2)], 'Color', colour, 'LineWidth', 2);
        
        if label
            text(mean([P1(1) P2(1)]),mean([P1(2) P2(2)]),num2str(parts.Seq{iRegion}(j)));
        end
    end
    
    
end

end