function imOut = tlMaskOnIm(im, mask, intensity, alpha)
    
    if ~exist('alpha','var')
        alpha=1;
    end

    % signature adapted from display_logical
    
    % im - grayscale or colour in [0, 1]
    % intensity - brightness scalar in [0, 1] or colour vector in [0, 1]
    
    imOut = im;

    if numel(intensity) == 1 && size(im,3) == 1
        intensity2 = (1-alpha)*imOut(mask) + alpha*intensity;
        imOut(mask) = intensity2;
    else
        if size(im,3) == 1
            imOut = repmat(im,[1 1 3]);
        end
        if numel(intensity) == 1
            intensity = intensity*ones(3,1);
        end
        for iCh=1:3
            chMask = false(size(im));
            chMask(:,:,iCh) = mask;
            
            intensity2 = (1-alpha)*imOut(chMask) + alpha*intensity(iCh);
            imOut(chMask) = intensity2;
        end
        %imOut = im2double(imOut);
    end
