function [ desc ] = de_desc( C,R,W,w,sspace )

% backward rigid transformation
C = C-w.pc;
R = R-w.pr;
CR = [cos(w.th) -sin(w.th); sin(w.th) cos(w.th)]' * [C(:)'; R(:)'];

% backward bending
rad = w.ar/w.b;
Rrad = sign(rad)*(rad-CR(2,:));
CR(2,:) = rad - sign(rad)*sqrt(CR(1,:).*CR(1,:) + Rrad.*Rrad);
CR(1,:) = abs(rad)*atan2(CR(1,:),Rrad);

% backward tapering
taper = (w.t/w.ac)*CR(1,:)+1;
CR(2,:) = CR(2,:)./taper;

% unscale
CR(1,:)=CR(1,:)/w.ac;
CR(2,:)=CR(2,:)/w.ar;


% spatial histograms
desc=hist_twoD(CR(2,:),CR(1,:),sspace,sspace,W);

desc = desc(:);


end

