function F = de_err(CR, w)
% CR  -  2xn points

ac=w(1);
ar=w(2);
theta=w(3);
pc=w(4);
pr=w(5);
t=w(6);
b=w(7);


% backward rigid transformation
CR(1,:) = CR(1,:)-pc;
CR(2,:) = CR(2,:)-pr;
CR = [cos(theta) sin(theta); -sin(theta) cos(theta)] * CR;

% % backward bending
rad = ar/b;
Rrad = sign(rad)*(rad-CR(2,:));
CR(2,:) = rad - sign(rad)*sqrt(CR(1,:).*CR(1,:) + Rrad.*Rrad);
CR(1,:) = abs(rad) * atan2(CR(1,:),Rrad);  % recovers angle (about rad) in [-pi,pi]

% backward tapering
taper = (t/ac)*CR(1,:)+1;
CR(2,:) = CR(2,:)./taper;

% evaluate at centred coordinates
% - reflect quadrants to upper-right so that F is non-singular
CR(1,:) = abs(CR(1,:))/ac;
CR(2,:) = abs(CR(2,:))/ar;
F0 = CR(1,:).*CR(1,:) + CR(2,:).*CR(2,:);

% F = F0-1;
F = sqrt(ac*ar)*(F0-1);

end

