function [ wfit fit ] = de_fit(X,Y,W,wi,lb,ub)

w0 = [wi.ac wi.ar wi.th wi.pc wi.pr wi.t wi.b]';

DisplayStr = 'off';

options = optimset( ...
    'Algorithm', 'trust-region-reflective', ...
    'Jacobian', 'off', ... % finite differences
    'Display', DisplayStr ...
    );
fun = @(w,X) de_err(X,w)';
xdata = [X(:)';Y(:)'];
ydata = zeros(length(X),1);                
[w,resnorm,residual,exitflag,output] = lsqcurvefit(fun,w0,xdata,ydata,lb,ub,options);

fit.w0 = w0;
fit.wstar = w;
% fit.resnorm = resnorm;
% fit.residual = residual;
% fit.exitflag = exitflag;
% fit.output = output;

illegal = any(w < lb) || any(w > ub);

if (isreal(w) && ~illegal)
    wfit.ac = w(1);
    wfit.ar = w(2);
    wfit.th = w(3);
    wfit.pc = w(4);
    wfit.pr = w(5);
    wfit.t = w(6);
    wfit.b = w(7);
else
    wfit = [];
end



end

