function funEval = getFeatureEvaluator(params)

switch params.feature.id
case 'Ellipse'
    h1 = load(sprintf('features/classifier_params_svm'),'classifier_params');
    h1 = h1.classifier_params;
    funEval = @(d149) evalFeatIccv09(d149,h1);
case 'DefDisc'
    load(sprintf('features/theta_Graph__uni_seq_%s.mat',params.feature.string),'theta');
    funEval = @(d149) train_pred(d149',theta);
end

end





function v = evalFeatIccv09(d149,h)
[affinity_shape, affinity_color] = evalFeatSubs(d149,h);
joint_affinity = [affinity_shape, affinity_color, 1];
v = LogisticPredict(joint_affinity, h.logistic);
end



function [affinity_shape, affinity_color] = evalFeatSubs(d149,h)

selected_features_idx = [1:100, 122:149];
desc128dim = d149(selected_features_idx)';

desc128dim(isnan(desc128dim) | isinf(desc128dim)) = 0;

% SVM
desc128dim = [desc128dim, 1];
[ tmp, predictions ] = svmclassify(desc128dim(1:100), 1, h.svm_model);
predictions = [predictions, 1];
affinity_shape = 1 / (1 + exp(-predictions * h.logistic_shape));
            
            
            color_features = desc128dim(:,[101:127,end]);
            num_features = numel(color_features);
            idx = tril(ones(num_features, num_features)) > 0;
            quad_features = color_features' * color_features;
            color_features = quad_features(idx(:))';
            
            affinity_color = LogisticPredict(color_features, h.logistic_color);
            
end
