function preprocessOneImage(idIm)

im = im2double(imread(sprintf('data/%s/%s.jpg',idIm,idIm)));

% compute edge map
pb_file = sprintf('preprocess/%s/%s-pb.mat',idIm,idIm);
if ~exist(pb_file, 'file')
    disp('Extracting edges using Pb..');
    [pb, theta, tmap] = pbCGTG(im);
    save(pb_file, 'pb', 'theta', 'tmap');
else
    load(pb_file);
end

% compute appearance features
image_data_file = sprintf('preprocess/%s/%s-data.mat',idIm,idIm);
if ~exist(image_data_file, 'file')
    disp('Computing appearance features..');
    image_data = PrecomputeImageData(im, pb, theta);
    save(image_data_file, 'image_data');
else
    load(image_data_file);
end
    
% compute superpixels
Nsups = [6 12 25 50 100 200];
InSups = 3:6;
for i=InSups
    superpixels_file = sprintf('preprocess/%s/%s-seg-scale%03d.seg',idIm,idIm,i);
    if ~exist(superpixels_file, 'file')    
        disp(['Computing ' num2str(Nsups(i)) ' superpixels using ncut..']);        
        imSeg = Superpixels_Ncuts_Pb(im, Nsups(i), image_data_file);
        writeSeg(imSeg, superpixels_file);
    else
        load(image_data_file);
    end
end
